package tests.javaee;

import ejbs.MapKeyOrderByRemote;
import entities.nomapkeyannotation.Course;
import entities.nomapkeyannotation.Student;
import java.util.HashMap;
import java.util.HashSet;
import java.util.Map;
import java.util.Set;
import javax.naming.InitialContext;
import testhelpers.assertionhelpers.AssertionHelper;

public class TestNoMapKeyAnnotation {
    
    private String testID;
    
    private AssertionHelper assertionHelper;
    
    private static int STUDENT_ID1 = 420;
    private static String STD_NAME1 = "Charsoubees";
    private static int STUDENT_ID2 = 421;
    private static String STD_NAME2 = "CharsouIkkis";
    
    private static  int MATH_ID = 104;
    private static String MATH_COURSE = "Math";

    private MapKeyOrderByRemote remoteObj;
    
    public TestNoMapKeyAnnotation(String testSuiteID, AssertionHelper assertionHelper) {
        this.testID = testSuiteID + "NoMapKeyAnnotation";
        this.assertionHelper = assertionHelper;
    }
    
    public void test() {
        try {
            remoteObj = (MapKeyOrderByRemote) new InitialContext().lookup("ejbs.MapKeyOrderByRemote");
            persistRelationship();
            assertCorrectMapKeyUsedOnCollection();
        } catch (Exception e) {
            assertionHelper.reportFailUnexpectedException(testID);
            e.printStackTrace();
        }
    }
    
    private void persistRelationship() {
        System.out.println("JavaEE: begin of persistRelationship");        
        Course math_course = createCourse(MATH_ID, MATH_COURSE);
        Student studentInMath_1 = createStudent(STUDENT_ID1, STD_NAME1, math_course);
        Student studentInMath_2 = createStudent(STUDENT_ID2, STD_NAME2, math_course);
        
        Map mathStudents = new HashMap();
        mathStudents.put(STUDENT_ID1, studentInMath_1);
        mathStudents.put(STUDENT_ID2, studentInMath_2);

        math_course.setStudents(mathStudents);

        Set collectionToPersist = new HashSet();
        collectionToPersist.add(math_course);
        collectionToPersist.add(studentInMath_1);
        collectionToPersist.add(studentInMath_2);
        System.out.println("JavaEE: before persist connectionToPersist="+collectionToPersist);        
        remoteObj.persistEntityCollection(collectionToPersist);

        System.out.println("JavaEE: end of persistRelationship");        
    }
    
    private void assertCorrectMapKeyUsedOnCollection() throws Exception {
        Course retrievedMath = remoteObj.getCourse(MATH_ID);
        
        Map<String, Student> mathStudents = retrievedMath.getStudents();
        System.out.println("JavaEE:retrievedMath="+retrievedMath);
        System.out.println("JavaEE:mathStudents="+mathStudents);
        if ( (mathStudents.get(STD_NAME1).getId() == STUDENT_ID1) &&
               (mathStudents.get(STD_NAME2).getId() == STUDENT_ID2) ) {
            assertionHelper.reportPass(testID);
        } else
            assertionHelper.reportFail(testID, "Expected to read relationship as a Map with students - " + STUDENT_ID1 + " and " + STUDENT_ID2 +
                    "; Actual Students in the Map - " + mathStudents.get(STD_NAME1).getId() + " and " + mathStudents.get(STD_NAME2).getId());
    }
    
    private Student createStudent(int id, String name, Course course) {
        Student student = new Student();
        student.setId(id);
        student.setName(name);
        student.setCourse(course);
        return student;
    }
    
    private Course createCourse(int id, String courseName) {
        Course course = new Course();
        course.setId(id);
        course.setName(courseName);
        return course;
    }
    
}
